// Module testing scripts
testAttached=true;

// mod.testSetKeyLed(addr, index, style);
// mod.testSetDispText(addr, index, text);
// mod.testSetIcon(addr, index, icon, flags);
// mod.testSetCBG(addr, index, style);

const testModNames=
[
	"FN Broadcast",
	"FN 4-fader",
	"FN Europhone",
	"FN US Phone",
	"FN Master",
	"FN User",
	"FN Production",
	"FN Combo",

	"EX Broadcast",
	"EX Accessory",
	"EX *2",
	"EX *3",
	"EX Intercom",
	"EX Cobalt",

	"Host",
	"Broadcast"
];
const testModTypes=
{
	FN_4FADER: 0x1,
	FN_EUPHONE:0x2,
	FN_USPHONE:0x3,
	FN_MASTER: 0x4,
	FN_USER:   0x5,
	FN_PROD:   0x6,
	FN_COMBO:  0x7,
	EX_ACCESS: 0x9
};
const testMasterId=0;
const testMasterAddr=(testModTypes.FN_MASTER<<4)|testMasterId;

var testModTable=[];
var testGUI=null;
var testActive=false;
var testCurrent=null;

/*
** testInitGUI
*/
function testInitGUI()
{
	var clrBg=gui.rgb(212, 208, 200);
	var n;

// background form
	testGUI.frmTest=gui.newFrame(null, 0, 0, 1024, 768, "");
	testGUI.frmTest.hide();

// title label
	testGUI.lblTitle=gui.newLabel(testGUI.frmTest, 770, 20, 250, 20, "", {
		font:"verdana-b-12",
		color:gui.rgb(0,0,0),
		bgcolor:clrBg,
		align:1,
		valign:0
	});
	testGUI.lblTitle.setText("Test Mode");

// Help text
	testGUI.lblHelp=gui.newLabel(testGUI.frmTest, 770, 670, 250, 18*5, "", {
			font:"verdana-10",
			color:gui.rgb(0,0,0),
			bgcolor:clrBg,
			align:0,
			valign:1
		});
	testGUI.lblHelp2=gui.newLabel(testGUI.frmTest, 20, 700, 730, 18*3, "", {
			font:"verdana-10",
			color:gui.rgb(0,0,0),
			bgcolor:clrBg,
			align:0,
			valign:1
		});

// modules list
	testGUI.lstModules=gui.newList(testGUI.frmTest, 770, 50, 250, 600, "", {
		font:"tahoma-10",
		bgcolor:clrBg,
		color:gui.rgb(0,0,0),
		selcolor:gui.rgb(255,255,255),
		selbgcolor:gui.rgb(10,36,106),
		acolor:gui.rgb(255,0,0),
		selacolor:gui.rgb(255,255,0),
		barcolor:gui.rgb(10,36,106),
		barw:4,
		sort:0
	});
	testGUI.lstModules.setColumns([150, 90]);
}

function testModule4fader(frame)
{
	var ctrls={};
	var n, x;

	frame.setBg("img/test/mod_fader.png");
	ctrls.keys=[];
	ctrls.faders=[];
	ctrls.rotary=null;
	ctrls.numDisp=4;
	ctrls.numIcons=4;
	ctrls.numLCD=0;
	ctrls.numCBG=0;

	for(n=0; n<4; n++)
	{
		x=71*n;

	// keys
		ctrls.keys[n*16+ 4]=gui.newPicture(frame, x+23, 105, 25, 25, "img/test/key_opt.png"); 	// Options
		ctrls.keys[n*16+ 0]=gui.newPicture(frame, x+ 7, 133, 25, 25, "img/test/key_pgm1.png");	// PGM1
		ctrls.keys[n*16+ 1]=gui.newPicture(frame, x+38, 133, 25, 25, "img/test/key_pgm2.png");	// PGM2
		ctrls.keys[n*16+ 2]=gui.newPicture(frame, x+ 7, 166, 25, 25, "img/test/key_pgm3.png");	// PGM3
		ctrls.keys[n*16+ 3]=gui.newPicture(frame, x+38, 166, 25, 25, "img/test/key_pgm4.png");	// PGM4

		ctrls.keys[n*16+10]=gui.newPicture(frame, x+ 7, 458, 25, 25, "img/test/key_talk.png");	// TalkBack
		ctrls.keys[n*16+11]=gui.newPicture(frame, x+38, 458, 25, 25, "img/test/key_prvw.png");	// Preview

		ctrls.keys[n*16+12]=gui.newPicture(frame, x+ 8, 532, 57, 24, "img/test/key_on.png");		// ON
		ctrls.keys[n*16+13]=gui.newPicture(frame, x+ 8, 565, 57, 24, "img/test/key_off.png");		// OFF
	}

	ctrls.faders[0]=gui.newPicture(frame,  19, 390, 34, 53, "img/test/fader.png"); ctrls.faders[0].x=19;
	ctrls.faders[1]=gui.newPicture(frame,  92, 390, 34, 53, "img/test/fader.png"); ctrls.faders[1].x=92;
	ctrls.faders[2]=gui.newPicture(frame, 161, 390, 34, 53, "img/test/fader.png"); ctrls.faders[2].x=161;
	ctrls.faders[3]=gui.newPicture(frame, 233, 390, 34, 53, "img/test/fader.png"); ctrls.faders[3].x=233;
	for(n=0; n<4; n++)
	{
		ctrls.faders[n].y=218;
		ctrls.faders[n].scale_h=225-53;
		ctrls.faders[n].val=-1;
		ctrls.faders[n].maxd=0;
	}

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=true;
	}

	return ctrls;
}

function testModuleEurophone(frame)
{
	var ctrls={};
	var n, x;

	frame.setBg("img/test/mod_eu.png");
	ctrls.keys=[];
	ctrls.faders=[];
	ctrls.rotary=null;
	ctrls.numDisp=4;
	ctrls.numIcons=4;
	ctrls.numLCD=0;
	ctrls.numCBG=0;

	for(n=0; n<4; n++)
	{
		x=71*n;

	// keys
		ctrls.keys[n*16+ 4]=gui.newPicture(frame, x+23, 105, 25, 25, "img/test/key_opt.png"); 	// Options
		ctrls.keys[n*16+ 0]=gui.newPicture(frame, x+ 7, 133, 25, 25, "img/test/key_pgm1.png");	// PGM1
		ctrls.keys[n*16+ 1]=gui.newPicture(frame, x+38, 133, 25, 25, "img/test/key_pgm2.png");	// PGM2
		ctrls.keys[n*16+ 2]=gui.newPicture(frame, x+ 7, 166, 25, 25, "img/test/key_pgm3.png");	// PGM3
		ctrls.keys[n*16+ 3]=gui.newPicture(frame, x+38, 166, 25, 25, "img/test/key_pgm4.png");	// PGM4

		ctrls.keys[n*16+ 8]=gui.newPicture(frame, x+ 7, 458, 25, 25, "img/test/key_set.png");	// TalkBack
		ctrls.keys[n*16+ 9]=gui.newPicture(frame, x+38, 458, 25, 25, "img/test/key_hold.png");	// Preview
		ctrls.keys[n*16+10]=gui.newPicture(frame, x+ 7, 495, 25, 25, "img/test/key_talk.png");	// TalkBack
		ctrls.keys[n*16+11]=gui.newPicture(frame, x+38, 495, 25, 25, "img/test/key_prvw.png");	// Preview

		ctrls.keys[n*16+12]=gui.newPicture(frame, x+ 8, 532, 57, 24, "img/test/key_on.png");		// ON
		ctrls.keys[n*16+13]=gui.newPicture(frame, x+ 8, 565, 57, 24, "img/test/key_off.png");		// OFF
	}

	ctrls.faders[0]=gui.newPicture(frame,  19, 390, 34, 53, "img/test/fader.png"); ctrls.faders[0].x=19;
	ctrls.faders[1]=gui.newPicture(frame,  92, 390, 34, 53, "img/test/fader.png"); ctrls.faders[1].x=92;
	ctrls.faders[2]=gui.newPicture(frame, 161, 390, 34, 53, "img/test/fader.png"); ctrls.faders[2].x=161;
	ctrls.faders[3]=gui.newPicture(frame, 233, 390, 34, 53, "img/test/fader.png"); ctrls.faders[3].x=233;
	for(n=0; n<4; n++)
	{
		ctrls.faders[n].y=218;
		ctrls.faders[n].scale_h=225-53;
		ctrls.faders[n].val=-1;
		ctrls.faders[n].maxd=0;
	}

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=true;
	}

	return ctrls;
}

function testModuleUSphone(frame)
{
	var ctrls={};
	var n, x;

	frame.setBg("img/test/mod_us.png");
	ctrls.keys=[];
	ctrls.faders=[];
	ctrls.rotary=null;
	ctrls.numDisp=2;
	ctrls.numIcons=26;
	ctrls.numLCD=0;
	ctrls.numCBG=0;

	for(n=0; n<2; n++)
	{
		x=71*3*n;

	// keys
		ctrls.keys[n*16+ 4]=gui.newPicture(frame, x+23, 105, 25, 25, "img/test/key_opt.png"); 	// Options
		ctrls.keys[n*16+ 0]=gui.newPicture(frame, x+ 7, 133, 25, 25, "img/test/key_pgm1.png");	// PGM1
		ctrls.keys[n*16+ 1]=gui.newPicture(frame, x+38, 133, 25, 25, "img/test/key_pgm2.png");	// PGM2
		ctrls.keys[n*16+ 2]=gui.newPicture(frame, x+ 7, 166, 25, 25, "img/test/key_pgm3.png");	// PGM3
		ctrls.keys[n*16+ 3]=gui.newPicture(frame, x+38, 166, 25, 25, "img/test/key_pgm4.png");	// PGM4

		ctrls.keys[n*16+ 8]=gui.newPicture(frame, x+ 7, 458, 25, 25, "img/test/key_set.png");	// TalkBack
		ctrls.keys[n*16+ 9]=gui.newPicture(frame, x+38, 458, 25, 25, "img/test/key_hold.png");	// Preview
		ctrls.keys[n*16+10]=gui.newPicture(frame, x+ 7, 495, 25, 25, "img/test/key_talk.png");	// TalkBack
		ctrls.keys[n*16+11]=gui.newPicture(frame, x+38, 495, 25, 25, "img/test/key_prvw.png");	// Preview

		ctrls.keys[n*16+12]=gui.newPicture(frame, x+ 8, 532, 57, 24, "img/test/key_on.png");		// ON
		ctrls.keys[n*16+13]=gui.newPicture(frame, x+ 8, 565, 57, 24, "img/test/key_off.png");		// OFF
	}

	ctrls.faders[0]=gui.newPicture(frame,  19, 390, 34, 53, "img/test/fader.png"); ctrls.faders[0].x=19;
	ctrls.faders[1]=gui.newPicture(frame, 233, 390, 34, 53, "img/test/fader.png"); ctrls.faders[1].x=233;
	for(n=0; n<2; n++)
	{
		ctrls.faders[n].y=218;
		ctrls.faders[n].scale_h=225-53;
		ctrls.faders[n].val=-1;
		ctrls.faders[n].maxd=0;
	}

// central group
	ctrls.keys[0x20+24]=gui.newPicture(frame, 105, 136, 26, 18, "img/test/key_call.png");		// call
	ctrls.keys[0x20+25]=gui.newPicture(frame, 154, 136, 26, 18, "img/test/key_block.png");	// block

	ctrls.keys[0x20+26]=gui.newPicture(frame,  87, 528, 26, 18, "img/test/key_drop.png");		// drop
	ctrls.keys[0x20+27]=gui.newPicture(frame, 129, 528, 26, 18, "img/test/key_next.png");		// next
	ctrls.keys[0x20+28]=gui.newPicture(frame, 172, 528, 26, 18, "img/test/key_drop.png");		// drop

// line keys and icons
	for(n=0; n<12; n++)
	{
		ctrls.keys[0x20+n+ 0]=gui.newPicture(frame,  83, 182+27*n, 26, 18, "img/test/key_empty.png");	// line
		ctrls.keys[0x20+n+12]=gui.newPicture(frame, 175, 182+27*n, 26, 18, "img/test/key_empty.png");	// line
	}

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=n<0x20?true:false;
	}

	return ctrls;
}

function testModuleMaster(frame)
{
	var ctrls={};
	var n, x;
	var rotLabel={font:"tahoma-7", color:gui.rgb(255,255,255), bgcolor:gui.rgb(152,152,152), align:0, valign:0};

	frame.setBg("img/test/mod_master.png");
	ctrls.keys=[];
	ctrls.faders=null;
	ctrls.rotary=[];
	ctrls.numDisp=0;
	ctrls.numIcons=0;
	ctrls.numLCD=0;
	ctrls.numCBG=0;

// Monitor knobs
	ctrls.rotary[0x00]=gui.newLabel(frame,  14, 245, 40, 35, "", rotLabel);
	ctrls.rotary[0x01]=gui.newLabel(frame,  92, 245, 40, 35, "", rotLabel);
	ctrls.rotary[0x02]=gui.newLabel(frame,  18, 553, 42, 42, "", rotLabel);
	ctrls.rotary[0x03]=gui.newLabel(frame,  87, 553, 42, 42, "", rotLabel);
	ctrls.rotary[0x04]=gui.newLabel(frame, 193, 483, 42, 42, "", rotLabel);
// Soft knobs:
	ctrls.rotary[0x05]=gui.newLabel(frame,   6,  22, 40, 35, "", rotLabel);
	ctrls.rotary[0x06]=gui.newLabel(frame,  49,  22, 40, 35, "", rotLabel);
	ctrls.rotary[0x07]=gui.newLabel(frame, 101,  22, 40, 35, "", rotLabel);
	ctrls.rotary[0x08]=gui.newLabel(frame, 144,  22, 40, 35, "", rotLabel);
	ctrls.rotary[0x09]=gui.newLabel(frame, 196,  22, 40, 35, "", rotLabel);
	ctrls.rotary[0x0A]=gui.newLabel(frame, 239,  22, 40, 35, "", rotLabel);

	for(n=0; n<16; n++)
		if(n in ctrls.rotary)
	{
		ctrls.rotary[n].maxd=0;
		ctrls.rotary[n].val=0;
		ctrls.rotary[n].setText("v 0\nd 0\nm 0");
	}

	ctrls.label=gui.newLabel(frame, 157, 600, 100, 14, "", rotLabel);

// Group 1a: channel options
	ctrls.keys[0x10]=gui.newPicture(frame,  63,  79, 25, 25, "img/test/key_src.png");			// source
	ctrls.keys[0x00]=gui.newPicture(frame,  14, 113, 25, 25, "img/test/key_eqd.png");			// eq & dynamics
	ctrls.keys[0x01]=gui.newPicture(frame,  46, 113, 25, 25, "img/test/key_pan.png");			// pan & mode
	ctrls.keys[0x02]=gui.newPicture(frame,  79, 113, 25, 25, "img/test/key_aux.png");			// aux sends
	ctrls.keys[0x03]=gui.newPicture(frame, 111, 113, 25, 25, "img/test/key_feed.png");		// feed to source
// Group 1b: master options
	ctrls.keys[0x11]=gui.newPicture(frame, 201,  79, 25, 25, "img/test/key_src.png");			// profile
	ctrls.keys[0x04]=gui.newPicture(frame, 153, 113, 25, 25, "img/test/key_prvw.png");		// monitor options
	ctrls.keys[0x05]=gui.newPicture(frame, 185, 113, 25, 25, "img/test/key_meter.png");		// meter options
	ctrls.keys[0x06]=gui.newPicture(frame, 218, 113, 25, 25, "img/test/key_send.png");		// sends & returns
	ctrls.keys[0x07]=gui.newPicture(frame, 250, 113, 25, 25, "img/test/key_fader.png");		// fader options
// Group 1c: delay
	ctrls.keys[0x08]=gui.newPicture(frame,  13, 176, 25, 25, "img/test/key_dump.png");		// dump
	ctrls.keys[0x09]=gui.newPicture(frame,  44, 176, 25, 25, "img/test/key_stop.png");		// exit
	ctrls.keys[0x0A]=gui.newPicture(frame,  78, 176, 25, 25, "img/test/key_pause.png");		// pause
	ctrls.keys[0x0B]=gui.newPicture(frame, 110, 176, 25, 25, "img/test/key_start.png");		// engage
// Group 1d: timer
	ctrls.keys[0x0C]=gui.newPicture(frame, 154, 176, 25, 25, "img/test/key_timer.png");		// timer options
	ctrls.keys[0x0D]=gui.newPicture(frame, 186, 176, 25, 25, "img/test/key_reset.png");		// reset
	ctrls.keys[0x0E]=gui.newPicture(frame, 219, 176, 25, 25, "img/test/key_pause.png");		// freeze display
	ctrls.keys[0x0F]=gui.newPicture(frame, 249, 176, 25, 25, "img/test/key_start.png");		// start & stop

// Group 2: monitors
	ctrls.keys[0x13]=gui.newPicture(frame,  22, 300, 25, 25, "img/test/key_talk.png");// talk to monitor 2
	ctrls.keys[0x14]=gui.newPicture(frame, 100, 300, 25, 25, "img/test/key_prevhp.png");	// preview to h/p
	ctrls.keys[0x15]=gui.newPicture(frame,  61, 339, 25, 25, "img/test/key_link.png");		// link
// link left
	ctrls.keys[0x18]=gui.newPicture(frame,  11, 369, 25, 25, "img/test/key_pgm1.png");// pgm 1
	ctrls.keys[0x19]=gui.newPicture(frame,  41, 369, 25, 25, "img/test/key_pgm2.png");// pgm 2
	ctrls.keys[0x1A]=gui.newPicture(frame,  11, 401, 25, 25, "img/test/key_pgm3.png");// pgm 3
	ctrls.keys[0x1B]=gui.newPicture(frame,  41, 401, 25, 25, "img/test/key_pgm4.png");// pgm 4
	ctrls.keys[0x1C]=gui.newPicture(frame,  11, 433, 25, 25, "img/test/key_auxa.png");		// aux a
	ctrls.keys[0x1D]=gui.newPicture(frame,  41, 433, 25, 25, "img/test/key_auxb.png");		// aux b
	ctrls.keys[0x1E]=gui.newPicture(frame,  11, 465, 25, 25, "img/test/key_auxc.png");		// aux c
	ctrls.keys[0x1F]=gui.newPicture(frame,  41, 465, 25, 25, "img/test/key_auxd.png");		// aux d
	ctrls.keys[0x20]=gui.newPicture(frame,  11, 498, 25, 25, "img/test/key_ext1.png");		// ext 1
	ctrls.keys[0x21]=gui.newPicture(frame,  41, 498, 25, 25, "img/test/key_ext2.png");		// ext 2
// link right
	ctrls.keys[0x22]=gui.newPicture(frame,  80, 369, 25, 25, "img/test/key_pgm1.png");// pgm 1
	ctrls.keys[0x23]=gui.newPicture(frame, 110, 369, 25, 25, "img/test/key_pgm2.png");// pgm 2
	ctrls.keys[0x24]=gui.newPicture(frame,  80, 401, 25, 25, "img/test/key_pgm3.png");// pgm 3
	ctrls.keys[0x25]=gui.newPicture(frame, 110, 401, 25, 25, "img/test/key_pgm4.png");// pgm 4
	ctrls.keys[0x26]=gui.newPicture(frame,  80, 433, 25, 25, "img/test/key_auxa.png");		// aux a
	ctrls.keys[0x27]=gui.newPicture(frame, 110, 433, 25, 25, "img/test/key_auxb.png");		// aux b
	ctrls.keys[0x28]=gui.newPicture(frame,  80, 465, 25, 25, "img/test/key_auxc.png");		// aux c
	ctrls.keys[0x29]=gui.newPicture(frame, 110, 465, 25, 25, "img/test/key_auxd.png");		// aux d
	ctrls.keys[0x2A]=gui.newPicture(frame,  80, 498, 25, 25, "img/test/key_ext1.png");		// ext 1
	ctrls.keys[0x2B]=gui.newPicture(frame, 110, 498, 25, 25, "img/test/key_ext2.png");		// ext 2

// Group 3: DTMF and navigation
	ctrls.keys[0x12]=gui.newPicture(frame, 201, 241, 25, 25, "img/test/key_engage.png");	// record engage

	ctrls.keys[0x2E]=gui.newPicture(frame, 157, 450, 26, 18, "img/test/key_help.png");		// help
	ctrls.keys[0x2F]=gui.newPicture(frame, 245, 450, 26, 18, "img/test/key_enter.png");		// enter

	ctrls.keys[0x3C]=gui.newPicture(frame, 201, 450, 26, 18, "img/test/key_up.png");				// up arrow
	ctrls.keys[0x3D]=gui.newPicture(frame, 201, 540, 26, 18, "img/test/key_down.png");			// down arrow
	ctrls.keys[0x3E]=gui.newPicture(frame, 157, 495, 26, 18, "img/test/key_left.png");			// left arrow
	ctrls.keys[0x3F]=gui.newPicture(frame, 245, 495, 26, 18, "img/test/key_right.png");			// right arrow

	ctrls.keys[0x31]=gui.newPicture(frame, 167, 305, 26, 18, "img/test/key_1.png");					// 1
	ctrls.keys[0x32]=gui.newPicture(frame, 201, 305, 26, 18, "img/test/key_2.png");					// 2
	ctrls.keys[0x33]=gui.newPicture(frame, 235, 305, 26, 18, "img/test/key_3.png");					// 3
	ctrls.keys[0x34]=gui.newPicture(frame, 167, 336, 26, 18, "img/test/key_4.png");					// 4
	ctrls.keys[0x35]=gui.newPicture(frame, 201, 336, 26, 18, "img/test/key_5.png");					// 5
	ctrls.keys[0x36]=gui.newPicture(frame, 235, 336, 26, 18, "img/test/key_6.png");					// 6
	ctrls.keys[0x37]=gui.newPicture(frame, 167, 366, 26, 18, "img/test/key_7.png");					// 7
	ctrls.keys[0x38]=gui.newPicture(frame, 201, 366, 26, 18, "img/test/key_8.png");					// 8
	ctrls.keys[0x39]=gui.newPicture(frame, 235, 366, 26, 18, "img/test/key_9.png");					// 9
	ctrls.keys[0x3A]=gui.newPicture(frame, 167, 397, 26, 18, "img/test/key_ast.png");				// *
	ctrls.keys[0x30]=gui.newPicture(frame, 201, 397, 26, 18, "img/test/key_0.png");					// 0
	ctrls.keys[0x3B]=gui.newPicture(frame, 235, 397, 26, 18, "img/test/key_num.png");				// #

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=n<0x2E?true:false;
	}

	return ctrls;
}

function testModuleCombo(frame)
{
	var ctrls={};
	var n, x;
	var rotLabel={font:"tahoma-7", color:gui.rgb(255,255,255), bgcolor:gui.rgb(152,152,152), align:0, valign:0};

	frame.setBg("img/test/mod_combo.png");
	ctrls.keys=[];
	ctrls.faders=[];
	ctrls.rotary=[];
	ctrls.numDisp=2;
	ctrls.numIcons=2;
	ctrls.numLCD=0;
	ctrls.numCBG=0;

	for(n=0; n<2; n++)
	{
		x=71*n;

	// keys
		ctrls.keys[n*16+ 4]=gui.newPicture(frame, x+23, 105, 25, 25, "img/test/key_opt.png"); 	// Options
		ctrls.keys[n*16+ 0]=gui.newPicture(frame, x+ 7, 133, 25, 25, "img/test/key_pgm1.png");	// PGM1
		ctrls.keys[n*16+ 1]=gui.newPicture(frame, x+38, 133, 25, 25, "img/test/key_pgm2.png");	// PGM2
		ctrls.keys[n*16+ 2]=gui.newPicture(frame, x+ 7, 166, 25, 25, "img/test/key_pgm3.png");	// PGM3
		ctrls.keys[n*16+ 3]=gui.newPicture(frame, x+38, 166, 25, 25, "img/test/key_pgm4.png");	// PGM4

		ctrls.keys[n*16+ 8]=gui.newPicture(frame, x+ 7, 458, 25, 25, "img/test/key_set.png");	// TalkBack
		ctrls.keys[n*16+ 9]=gui.newPicture(frame, x+38, 458, 25, 25, "img/test/key_hold.png");	// Preview
		ctrls.keys[n*16+10]=gui.newPicture(frame, x+ 7, 495, 25, 25, "img/test/key_talk.png");	// TalkBack
		ctrls.keys[n*16+11]=gui.newPicture(frame, x+38, 495, 25, 25, "img/test/key_prvw.png");	// Preview

		ctrls.keys[n*16+12]=gui.newPicture(frame, x+ 8, 532, 57, 24, "img/test/key_on.png");		// ON
		ctrls.keys[n*16+13]=gui.newPicture(frame, x+ 8, 565, 57, 24, "img/test/key_off.png");		// OFF
	}

// Monitor knobs
	ctrls.rotary[0x00]=gui.newLabel(frame, 231, 359, 40, 35, "", rotLabel);
	ctrls.rotary[0x01]=gui.newLabel(frame, 231, 447, 40, 35, "", rotLabel);
	ctrls.rotary[0x02]=gui.newLabel(frame, 158, 536, 42, 42, "", rotLabel);
	ctrls.rotary[0x03]=gui.newLabel(frame, 228, 536, 42, 42, "", rotLabel);
// Soft knobs:
	ctrls.rotary[0x04]=gui.newLabel(frame, 154,  21, 40, 35, "", rotLabel);
	ctrls.rotary[0x05]=gui.newLabel(frame, 197,  21, 40, 35, "", rotLabel);
	ctrls.rotary[0x06]=gui.newLabel(frame, 241,  21, 40, 35, "", rotLabel);

	for(n=0; n<16; n++)
		if(n in ctrls.rotary)
	{
		ctrls.rotary[n].maxd=0;
		ctrls.rotary[n].val=0;
		ctrls.rotary[n].setText("v 0\nd 0\nm 0");
	}

// Group: options
	ctrls.keys[0x20]=gui.newPicture(frame, 169, 222, 25, 25, "img/test/key_engage.png");	// record engage
	ctrls.keys[0x21]=gui.newPicture(frame, 233, 222, 25, 25, "img/test/key_src.png");			// profile
// Group: timer
	ctrls.keys[0x22]=gui.newPicture(frame, 152, 268, 25, 25, "img/test/key_timer.png");		// timer options
	ctrls.keys[0x23]=gui.newPicture(frame, 185, 268, 25, 25, "img/test/key_reset.png");		// reset
	ctrls.keys[0x24]=gui.newPicture(frame, 218, 268, 25, 25, "img/test/key_pause.png");		// freeze display
	ctrls.keys[0x25]=gui.newPicture(frame, 250, 268, 25, 25, "img/test/key_start.png");		// start & stop
// Group: monitors
	ctrls.keys[0x26]=gui.newPicture(frame, 167, 362, 25, 25, "img/test/key_src.png");			// monitor options
	ctrls.keys[0x27]=gui.newPicture(frame, 238, 403, 25, 25, "img/test/key_talk.png");// talk to monitor 2
	ctrls.keys[0x28]=gui.newPicture(frame, 153, 417, 25, 25, "img/test/key_pgm1.png");// pgm 1
	ctrls.keys[0x29]=gui.newPicture(frame, 181, 417, 25, 25, "img/test/key_pgm2.png");// pgm 2
	ctrls.keys[0x2A]=gui.newPicture(frame, 153, 444, 25, 25, "img/test/key_pgm3.png");// pgm 3
	ctrls.keys[0x2B]=gui.newPicture(frame, 181, 444, 25, 25, "img/test/key_pgm4.png");// pgm 4
	ctrls.keys[0x2C]=gui.newPicture(frame, 153, 486, 25, 25, "img/test/key_ext1.png");		// ext 1
	ctrls.keys[0x2D]=gui.newPicture(frame, 181, 486, 25, 25, "img/test/key_ext2.png");		// ext 2
	ctrls.keys[0x2E]=gui.newPicture(frame, 238, 489, 25, 25, "img/test/key_prevhp.png");	// preview to h/p
// Key Group: DTMF
	ctrls.keys[0x31]=gui.newPicture(frame, 168,  91, 26, 18, "img/test/key_1.png");					// 1
	ctrls.keys[0x32]=gui.newPicture(frame, 202,  91, 26, 18, "img/test/key_2.png");					// 2
	ctrls.keys[0x33]=gui.newPicture(frame, 236,  91, 26, 18, "img/test/key_3.png");					// 3
	ctrls.keys[0x34]=gui.newPicture(frame, 168, 122, 26, 18, "img/test/key_4.png");					// 4
	ctrls.keys[0x35]=gui.newPicture(frame, 202, 122, 26, 18, "img/test/key_5.png");					// 5
	ctrls.keys[0x36]=gui.newPicture(frame, 236, 122, 26, 18, "img/test/key_6.png");					// 6
	ctrls.keys[0x37]=gui.newPicture(frame, 168, 150, 26, 18, "img/test/key_7.png");					// 7
	ctrls.keys[0x38]=gui.newPicture(frame, 202, 150, 26, 18, "img/test/key_8.png");					// 8
	ctrls.keys[0x39]=gui.newPicture(frame, 236, 150, 26, 18, "img/test/key_9.png");					// 9
	ctrls.keys[0x3A]=gui.newPicture(frame, 168, 180, 26, 18, "img/test/key_ast.png");				// *
	ctrls.keys[0x30]=gui.newPicture(frame, 202, 180, 26, 18, "img/test/key_0.png");					// 0
	ctrls.keys[0x3B]=gui.newPicture(frame, 236, 180, 26, 18, "img/test/key_num.png");				// #


	ctrls.faders[0]=gui.newPicture(frame,  19, 390, 34, 53, "img/test/fader.png"); ctrls.faders[0].x=19;
	ctrls.faders[1]=gui.newPicture(frame,  92, 390, 34, 53, "img/test/fader.png"); ctrls.faders[1].x=92;
	for(n=0; n<2; n++)
	{
		ctrls.faders[n].y=218;
		ctrls.faders[n].scale_h=225-53;
		ctrls.faders[n].val=-1;
		ctrls.faders[n].maxd=0;
	}

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=n<0x30?true:false;
	}

	return ctrls;
}

function testModuleUser(frame, subtype)
{
	var ctrls={};
	var n, x;
	var numKeys, keyType;

	switch((subtype>>4))
	{
	case  0: numKeys= 5; keyType=1; break;
	case  1: numKeys=10; keyType=1; break;
	case  2: numKeys= 5; keyType=2; break;
	case  3: numKeys=10; keyType=2; break;
	case  4: numKeys= 5; keyType=3; break;
	case  5: numKeys=10; keyType=3; break;
	default: numKeys= 0; keyType=0; break;
	}

	frame.setBg("img/test/mod_usr.png");
	ctrls.keys=[];
	ctrls.faders=null;
	ctrls.rotary=null;
	ctrls.numDisp=1;
	ctrls.numIcons=0;
	ctrls.numLCD=(keyType==2 || keyType==3)?numKeys:0;
	ctrls.numCBG=0;

	for(n=0; n<5; n++)
	{
		ctrls.keys[n]=gui.newPicture(frame, 9, 352+(4-n)*48, 54, 42, "img/test/key_ss.png");
		if(numKeys==10)
			ctrls.keys[5+n]=gui.newPicture(frame, 9, 86+(4-n)*48, 54, 42, "img/test/key_ss.png");
	}

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=true;
	}

	return ctrls;
}

function testModuleProd(frame)
{
	var ctrls={};
	var n, x;
	var rotLabel={font:"tahoma-7", color:gui.rgb(255,255,255), bgcolor:gui.rgb(152,152,152), align:0, valign:0};
	var knob_y=[116,185,262,331,400,477,545];

	frame.setBg("img/test/mod_production.png");
	ctrls.keys=[];
	ctrls.faders=null;
	ctrls.rotary=[];
	ctrls.numDisp=1;
	ctrls.numIcons=1;
	ctrls.numLCD=0;
	ctrls.numCBG=14;

	for(n=0; n<7; n++)
	{
		ctrls.rotary[n*2+0]=gui.newLabel(frame, 24-7, knob_y[n]-10, 40, 35, "", rotLabel);
		ctrls.rotary[n*2+1]=gui.newLabel(frame, 91-7, knob_y[n]-10, 40, 35, "", rotLabel);
	}
	ctrls.rotary[14]=gui.newLabel(frame, 14, 21, 40, 35, "", rotLabel);

	for(n=0; n<16; n++)
		if(n in ctrls.rotary)
	{
		ctrls.rotary[n].maxd=0;
		ctrls.rotary[n].val=0;
		ctrls.rotary[n].setText("v 0\nd 0\nm 0");
	}

	for(n=0; n<16; n++)
		ctrls.keys[n]={led:true, key:false};

	return ctrls;
}

function testModuleAccess(frame, subtype)
{
	var ctrls={};
	var n;
	var rotLabel={font:"tahoma-7", color:gui.rgb(255,255,255), bgcolor:gui.rgb(152,152,152), align:0, valign:0};

	ctrls.keys=[];
	ctrls.faders=null;
	ctrls.rotary=[];
	ctrls.numIcons=0;
	ctrls.numLCD=0;
	ctrls.numCBG=0;

	switch((subtype>>4))
	{
	case 1:	// 4 LCD
		frame.setBg("img/test/mod_access1.png");
		ctrls.numDisp=0;
		ctrls.numLCD=4;
		ctrls.label=gui.newLabel(frame, 3, 244, 85, 14, "", rotLabel);
		for(n=0; n<4; n++)
			ctrls.keys[n]=gui.newPicture(frame, 15, 40+(3-n)*48, 54, 42, "img/test/key_ss.png");
		break;
	case 2: // HP selector
		frame.setBg("img/test/mod_access2.png");
		ctrls.numDisp=1;
		ctrls.rotary[0]=gui.newLabel(frame, 23, 61, 40, 35, "", rotLabel);
		ctrls.keys[0]=gui.newPicture(frame, 16, 116, 25, 25, "img/test/key_flat.png");	// preset1
		ctrls.keys[1]=gui.newPicture(frame, 46, 116, 25, 25, "img/test/key_flat.png");		// preset1
		break;
	case 3: // HP microphone
		frame.setBg("img/test/mod_access3.png");
		ctrls.numDisp=1;
		ctrls.rotary[0]=gui.newLabel(frame, 23, 61, 40, 35, "", rotLabel);
		ctrls.keys[0]=gui.newPicture(frame, 16, 116, 25, 25, "img/test/key_talk.png");	// preset1
		ctrls.keys[1]=gui.newPicture(frame, 46, 116, 25, 25, "img/test/key_flat.png");			// preset1
		ctrls.keys[2]=gui.newPicture(frame, 14, 160, 57, 24, "img/test/key_on.png");		// ON
		ctrls.keys[3]=gui.newPicture(frame, 14, 203, 57, 24, "img/test/key_off.png");		// OFF
		break;
	default:
		return null;
	}

	for(n=0; n<16; n++)
		if(n in ctrls.rotary)
	{
		ctrls.rotary[n].maxd=0;
		ctrls.rotary[n].val=0;
		ctrls.rotary[n].setText("v 0\nd 0\nm 0");
	}

	for(n=0; n<64; n++)
		if(n in ctrls.keys)
	{
		ctrls.keys[n].key=true;
		ctrls.keys[n].led=true;
	}

	return ctrls;
}

/*
** testBegin
*/
function testBegin()
{
	if(testGUI==null)
	{
		testGUI={};
		testInitGUI();
	}

	var txt=host.sprintf("You need Master Module\nwith ID:%X (module [4:%X])\nto use Test mode!\n[HELP] / [0] - Exit test mode", testMasterId, testMasterId)
	testGUI.lblHelp.setText(txt);

	bgframe.hide();
	testGUI.frmTest.show();

	testModTable=[];
	testCurrent=null;
	testActive=true;
}

/*
** testEnd
*/
function testEnd()
{
	testGUI.frmTest.hide();
	bgframe.show();

	testModTable=[];
	testActive=false;
	testFinish();

	mod.testEnd();
}

/*
** testFillList
*/
function testFillList()
{
	var txt;
	var n;

	testGUI.lstModules.clear();
	testGUI.lstModules.hide();
	for(n=0; n<255; n++)
	{
		if(!(n in testModTable)) continue;

		txt=host.sprintf("[%X:%X] %s\t%s/%d/%02X", testModTable[n].type, testModTable[n].id, testModNames[testModTable[n].type], testModTable[n].fw_ver, testModTable[n].hw_ver, testModTable[n].fw_type);
		testGUI.lstModules.insert(txt, n, 0, 0);
		testGUI.lstModules.select(0);
	}
	testGUI.lstModules.show();
}

/*
** testStart
*/
function testStart(id)
{
	if(id==0 || !(id in testModTable)) return;
// finish test first
	testFinish();

	testCurrent={};
	testCurrent.addr=id;
	testCurrent.type=testModTable[id].type;
	testCurrent.id=testModTable[id].id;
	testCurrent.frame=gui.newFrame(testGUI.frmTest, 240, 20, 285, 616, "");

	switch(testCurrent.type)
	{
	case testModTypes.FN_4FADER:
		testCurrent.mod=testModule4fader(testCurrent.frame);
		break;
	case testModTypes.FN_EUPHONE:
		testCurrent.mod=testModuleEurophone(testCurrent.frame);
		break;
	case testModTypes.FN_USPHONE:
		testCurrent.mod=testModuleUSphone(testCurrent.frame);
		break;
	case testModTypes.FN_MASTER:
		testCurrent.mod=testModuleMaster(testCurrent.frame);
		break;
	case testModTypes.FN_USER:
		testCurrent.mod=testModuleUser(testCurrent.frame, testModTable[id].fw_type);
		break;
	case testModTypes.FN_PROD:
		testCurrent.mod=testModuleProd(testCurrent.frame);
		break;
	case testModTypes.EX_ACCESS:
		testCurrent.mod=testModuleAccess(testCurrent.frame, testModTable[id].fw_type);
		break;
	case testModTypes.FN_COMBO:
		testCurrent.mod=testModuleCombo(testCurrent.frame);
		break;
	default:
		testCurrent.frame.destroy();
		testCurrent.mod=null;
		return;
	}
	if(testCurrent.mod==null)
	{
		testCurrent.frame.destroy();
		testCurrent=null;
		return;
	}
	testModTable[id].current=true;

	testStartTest1();
}

/*
** testFinish
*/
function testFinish()
{
	if(testCurrent==null) return;

	if(testCurrent.addr in testModTable)
		testModTable[testCurrent.addr].current=false;
	testCurrent.frame.destroy();
	testCurrent=null;
	testGUI.lblHelp2.setText("");
}

function testStartTest1()
{
	var n;
	var nkeys;

	if(testCurrent==null) return;

// setup for the 1st test
	testCurrent.test=1;
	nkeys=0;
	for(n=0; n<64; n++)
	{
		if(!(n in testCurrent.mod.keys) || !testCurrent.mod.keys[n].key) continue;
		nkeys++;
		testCurrent.mod.keys[n].val=2;	// 2 means not pressed, not released
		if(testCurrent.mod.keys[n].led)
		{
			testCurrent.mod.keys[n].setIndex(1, 1);
			mod.testSetKeyLed(testCurrent.addr, n, 255);
		}
		else
			testCurrent.mod.keys[n].setIndex(1, 0);
	}
	testCurrent.nkeys=nkeys;
	testGUI.lblHelp2.setText
	(
		"Test 1: Button and button LED test.\n"+
		"Press each button on the module to turn off each LED.\n"+
		testCurrent.nkeys+" keys left."
	);
}

function test2Loop()
{
	var n=-1;
	var ndx;
	var ni=1, nd=1, nl=1, nc=1;
	var f;

// set thread title
	host.setTitle("Test 2 loop");

	while(testActive && testCurrent!=null && testCurrent.test==2)
	{
		if(!testCurrent.dynamic || testCurrent.mod.numLCD==0)
		{
		/* switch off key sequence during dynamic LDC testing */
			if(n!=-1 && (n in testCurrent.mod.keys) && testCurrent.mod.keys[n].led)
			{
				if(testCurrent.mod.keys[n].key)
					testCurrent.mod.keys[n].setIndex(-1, 0);
				mod.testSetKeyLed(testCurrent.addr, n, 0);
			}

			for(f=0; f<64; f++)
			{
				if(++n==64) n=0;
				if((n in testCurrent.mod.keys) && testCurrent.mod.keys[n].led) break;
			}

			if((n in testCurrent.mod.keys) && testCurrent.mod.keys[n].led)
			{
				if(testCurrent.mod.keys[n].key)
					testCurrent.mod.keys[n].setIndex(-1, 1);
				mod.testSetKeyLed(testCurrent.addr, n, 255);
			}
		}

		if(testCurrent.dynamic)
		{
			for(ndx=0; ndx<testCurrent.mod.numIcons; ndx++)
				mod.testSetIcon(testCurrent.addr, ndx, ni, 512);
			if(++ni>7) ni=1;
			for(ndx=0; ndx<testCurrent.mod.numLCD; ndx++)
				mod.testSetIcon(testCurrent.addr, ndx, nl, 1024);
			if(++nl>32) nl=1;
			for(ndx=0; ndx<testCurrent.mod.numDisp; ndx++)
				mod.testSetIcon(testCurrent.addr, ndx, nd, 2048);
			if(++nd>50) nd=1;
			for(ndx=0; ndx<testCurrent.mod.numCBG; ndx++)
				mod.testSetCBG(testCurrent.addr, ndx, 1<<(nc-1));
			if(++nc>15) nc=1;
		}

		host.sleep(250);
	}
}

function test2static()
{
	var ndx;
	testCurrent.dynamic=false;

	for(ndx=0; ndx<testCurrent.mod.numIcons; ndx++)
		mod.testSetIcon(testCurrent.addr, ndx, 255, 512);
	for(ndx=0; ndx<testCurrent.mod.numLCD; ndx++)
		mod.testSetIcon(testCurrent.addr, ndx, 255, 1024);
	for(ndx=0; ndx<testCurrent.mod.numDisp; ndx++)
		mod.testSetIcon(testCurrent.addr, ndx, 255, 2048);
	for(ndx=0; ndx<testCurrent.mod.numCBG; ndx++)
		mod.testSetCBG(testCurrent.addr, ndx, 0x7FFF);
}

function test2dynamic()
{
	var ndx;

	testCurrent.dynamic=true;
/* turn all LCD led's on */
	for(ndx=0; ndx<testCurrent.mod.numLCD; ndx++)
		mod.testSetKeyLed(testCurrent.addr, ndx, 255);
}

function testStartTest2()
{
	var n;

	if(testCurrent==null) return;

// setup for the 2nd test
	testCurrent.test=2;
	test2static();

	for(n=0; n<64; n++)
	{
		if(!(n in testCurrent.mod.keys)) continue;
		if(testCurrent.mod.keys[n].led)
			mod.testSetKeyLed(testCurrent.addr, n, 0);
		if(testCurrent.mod.keys[n].key)
			testCurrent.mod.keys[n].setIndex(0, 0);
	}
	host.setTimeout(250, test2Loop);

	testGUI.lblHelp2.setText
	(
		"Test 2: Visual elements test.\n"+
		"Observe if all displays and icons are fully lit. Key LEDs are lit in a loop sequence.\n"+
		"Press any key on module to switch static/dynamic test. When finished, press [RIGHT] to continue."
	);
}

function testStartTest3()
{
	var n;

	if(testCurrent==null) return;

// setup for the 2nd test
	testCurrent.test=3;

	if(testCurrent.mod.faders!=null)
	{
		for(n=0; n<16; n++)
		{
			if(!(n in testCurrent.mod.faders)) continue;
			testCurrent.mod.faders[n].val=-1;
			testCurrent.mod.faders[n].maxd=0;
			mod.testSetDispText(testCurrent.addr, n, host.sprintf("%4d  %4d", 0, 0));
		}
	}
	if(testCurrent.mod.rotary!=null)
	{
		for(n=0; n<16; n++)
		{
			if(!(n in testCurrent.mod.rotary)) continue;
			testCurrent.mod.rotary[n].maxd=0;
			testCurrent.mod.rotary[n].setText(host.sprintf("v %d\nd %d\nm %d", testCurrent.mod.rotary[n].val, 0, 0));
		}
	}

	testGUI.lblHelp2.setText
	(
		"Test 3: Fader and Rotary Encoder test.\n"+
		"Slowly move each fader or rotate a knob and observe delta, Press [OFF]/[ENTER] to clear fader/rotary delta.\n"+
		"When finished, press [RIGHT] to continue."
	);
}

// ------------------------- * Processing * -------------------------

/*
** testOnMasterKey
*/
function testOnMasterKey(key)
{
	switch(key)
	{
	case keys.MstUp:
		testGUI.lstModules.advance(-1);
		break;
	case keys.MstDown:
		testGUI.lstModules.advance(1);
		break;
	case keys.MstRight:
		if(testCurrent==null) return;
		switch(testCurrent.test)
		{
		case 1:
			testStartTest2();
			break;
		case 2:
			testStartTest3();
			break;
		default:
			testFinish();
			break;
		}
		break;
	case keys.MstLeft:
		if(testCurrent==null) return;
		switch(testCurrent.test)
		{
		case 3:
			testStartTest2();
			break;
		case 2:
			testStartTest1();
			break;
		default:
			testFinish();
			break;
		}
		break;
	case keys.MstHelp:
	case keys.MstNum0:
		testEnd();
		break;
	case keys.MstEnter:
		testStart(testGUI.lstModules.selId);
		break;
	}
}

function testOnCurrentKeyDown(key)
{
	if(testCurrent==null) return;
	if(testCurrent.test==1)
	{
		var msg=host.sprintf("%3d down", key);
		if(testCurrent.mod.numDisp==0)
			testCurrent.mod.label.setText(msg);
		else
			mod.testSetDispText(testCurrent.addr, 0, msg);
	}
	if(testCurrent.test==3 && key>=128 && testCurrent.mod.rotary!=null && ((key-128) in testCurrent.mod.rotary))
	{
	// knob
		testCurrent.mod.rotary[key-128].maxd=0;
		testCurrent.mod.rotary[key-128].setText(host.sprintf("v %d\nd %d\nm %d", testCurrent.mod.rotary[key-128].val, 0, 0));
		return;
	}
	if(testCurrent.test==2)
	{
		if(testCurrent.dynamic)
			test2static();
		else
			test2dynamic();
	}
	if(testCurrent.mod.keys==null || !(key in testCurrent.mod.keys)) return;

	if(testCurrent.test==1)
	{
		if(testCurrent.mod.keys[key].val==2) testCurrent.mod.keys[key].val=1;
		if(testCurrent.mod.keys[key].led)
		{
			testCurrent.mod.keys[key].setIndex(-1, 1);
			mod.testSetKeyLed(testCurrent.addr, key, 255);
		}
		else
			testCurrent.mod.keys[key].setIndex(-1, 0);
	}
	else if(testCurrent.test==3 && testCurrent.mod.faders!=null)
	{
		var ch=key>>4;
		var ck=key&0x0F;

		if(ck==keys.ChnOFF && (ch in testCurrent.mod.faders))
		{
			testCurrent.mod.faders[ch].maxd=0;
			mod.testSetDispText(testCurrent.addr, ch, host.sprintf("%4d  %4d", testCurrent.mod.faders[ch].val>>6, 0));
		}
	}
	else if(testCurrent.test==3 && testCurrent.mod.rotary!=null && key==keys.MstEnter)
	{
		var n;

		for(n=0; n<16; n++)
		{
			if(!(n in testCurrent.mod.rotary)) continue;
			testCurrent.mod.rotary[n].maxd=0;
			testCurrent.mod.rotary[n].setText(host.sprintf("v %d\nd %d\nm %d", testCurrent.mod.rotary[n].val, 0, 0));
		}
	}

	testCurrent.mod.keys[key].setIndex(2, -1);
}

function testOnCurrentKeyUp(key)
{
	if(testCurrent==null) return;
	if(testCurrent.test==1)
	{
		var msg=host.sprintf("%3d up", key);
		if(testCurrent.mod.numDisp==0)
			testCurrent.mod.label.setText(msg);
		else
			mod.testSetDispText(testCurrent.addr, 0, msg);
	}
	if(testCurrent.mod.keys==null || !(key in testCurrent.mod.keys)) return;

	if(testCurrent.test==1)
	{
		if(testCurrent.mod.keys[key].val==1)
		{
			testCurrent.mod.keys[key].val=0;
			testCurrent.nkeys--;
			testGUI.lblHelp2.setText
			(
				"Test 1: Button and button LED test.\n"+
				"Press each button on the module to turn off each LED.\n"+
				(testCurrent.nkeys>0?(testCurrent.nkeys+" keys left"):"All keys tested, press [RIGHT] to continue.")
			);
		}
		else if(testCurrent.mod.keys[key].val==2)
		{
		// some error
			testCurrent.mod.keys[key].setIndex(1, 1);
			return;
		}
		if(testCurrent.mod.keys[key].led)
		{
			testCurrent.mod.keys[key].setIndex(-1, 0);
			mod.testSetKeyLed(testCurrent.addr, key, 0);
		}
	}

	testCurrent.mod.keys[key].setIndex(0, -1);
}

function testOnCurrentFader(index, value)
{
	var old_val;

	if(testCurrent==null || testCurrent.mod.faders==null || !(index in testCurrent.mod.faders)) return;

	if(testCurrent.test==3)
	{
		old_val=testCurrent.mod.faders[index].val;
		testCurrent.mod.faders[index].val=value;
		if(old_val==-1) old_val=value;
		old_val=Math.abs(value-old_val);
		if(old_val>testCurrent.mod.faders[index].maxd)
			testCurrent.mod.faders[index].maxd=old_val;
		mod.testSetDispText(testCurrent.addr, index, host.sprintf("%4d  %4d", value>>6, testCurrent.mod.faders[index].maxd>>6));
	}

	testCurrent.mod.faders[index].moveTo(testCurrent.mod.faders[index].x, testCurrent.mod.faders[index].y+testCurrent.mod.faders[index].scale_h*(0xFFFF-value)/0xFFFF);
}

function testOnCurrentKnob(index, value, delta)
{
	if(testCurrent==null || testCurrent.mod.rotary==null || !(index in testCurrent.mod.rotary)) return;

	if(testCurrent.mod.rotary[index].maxd<Math.abs(delta))
		testCurrent.mod.rotary[index].maxd=Math.abs(delta);
	testCurrent.mod.rotary[index].val=value;

	testCurrent.mod.rotary[index].setText(host.sprintf("v %d\nd %d\nm %d", value, delta, testCurrent.mod.rotary[index].maxd));
}

// ------------------------- * Host->Script functions * -------------------------

/*
** testOnActivate
**
** new module is added to system
*/
function testOnActivate(type, id, hw_ver, fw_ver, fw_type)
{
	var addr=(type<<4)|id;

	if(!testActive)
	{
		testBegin();
	}

// check for activated module
	if(addr in testModTable) testOnDeactivate(type, id);

	if(addr==testMasterAddr)
	{
	// this is Master module with ID:0, it is used as main master
		testGUI.lblHelp.setText("[UP] [DOWN] - Select Module\n[ENTER] - Begin testing\n\n[HELP] / [0] - Exit test mode");
		return;
	}

	testModTable[addr]=
	{
		type:type,
		id:id,
		addr:addr,
		hw_ver:hw_ver,
		fw_ver:fw_ver,
		fw_type:fw_type,
		current:false
	};
	testFillList();
}

/*
** testOnDeactivate
**
** new module is added to system
*/
function testOnDeactivate(type, id)
{
	var addr=(type<<4)|id;

	if(addr==testMasterAddr)
	{
	// this is Master module with ID:0, it is used as main master
		var txt=host.sprintf("You need Master Module\nwith ID:%X (module [4:%X])\nto use Test mode!\n[HELP] / [0] - Exit test mode", testMasterId, testMasterId)
		testGUI.lblHelp.setText(txt);
		return;
	}

// check for inactive anyway
	if(!(addr in testModTable)) return;

	if(testModTable[addr].current)
	{
	// notify user that current test module is gone :(
		testFinish();
	}

	testModTable[addr]=null;
	delete testModTable[addr];
	testFillList();
}

/*
** testOnKeyDown
*/
function testOnKeyDown(type, id, key)
{
	var addr=(type<<4)|id;

	if(addr==testMasterAddr)
	{
	// Master key event
		testOnMasterKey(key);
		return;
	}

	if((addr in testModTable) && testModTable[addr].current)
	{
		testOnCurrentKeyDown(key);
	// Current module event
		return;
	}

// emergency exit
	if((type==testModTypes.FN_MASTER && (key==keys.MstHelp || key==keys.MstNum0))
	|| (type==testModTypes.FN_COMBO  && key==keys.MstNum0))
	{
	// end of test mode
		testEnd();
		return;
	}
}

/*
** testOnKeyUp
*/
function testOnKeyUp(type, id, key)
{
	var addr=(type<<4)|id;

	if(addr==testMasterAddr)
	{
	// Master key event
		return;
	}

	if((addr in testModTable) && testModTable[addr].current)
	{
	// Current module event
		testOnCurrentKeyUp(key);
		return;
	}
}

/*
** testOnFaderMove
*/
function testOnFaderMove(type, id, index, value)
{
	var addr=(type<<4)|id;

	if(addr==testMasterAddr)
	{
	// Master key event
		return;
	}

	if((addr in testModTable) && testModTable[addr].current)
	{
	// Current module event
		testOnCurrentFader(index, value);
		return;
	}
}

/*
** testOnKnobRotate
*/
function testOnKnobRotate(type, id, index, value, delta)
{
	var addr=(type<<4)|id;

	if(addr==testMasterAddr)
	{
	// Master key event
		return;
	}

	if((addr in testModTable) && testModTable[addr].current)
	{
	// Current module event
		testOnCurrentKnob(index, value, delta);
		return;
	}
}
