// ------------------------ channel pan page ------------------------

function chpanKnobFocus(on)
{
	var prop=on?propAct:propOff;

	this.val.setProps(prop);
	this.lbl.setProps(prop);
	this.knob.setIndex(on?2:0);
}

function chpanPageCreate()
{
	var p={id:"chpan"};
	var f;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 145, 12, "img/channel_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);

	var pan_fr=gui.newFrame(f, 49, 131, 356, 219, "img/ch_edit_pan_bg.png");

	p.pan=
	{
		val:  gui.newLabel(pan_fr, 36, 155, 80, 14, '', prop_value),
		knob: gui.newKnob (pan_fr, 65, 172, 22, 22, "img/knob_22px.png"),
		lbl:  gui.newLabel(pan_fr, 36, 195, 80, 14, '', prop_value),
		name: "PAN",
		angle: 0,
		focus: chpanKnobFocus
	};
	p.pan.lbl.setText("PAN");

	p.mode=
	{
		val:  gui.newLabel(pan_fr, 124, 155, 100, 14, '', prop_value),
		knob: gui.newKnob (pan_fr, 163, 172,  22, 22, "img/knob_22px.png"),
		lbl:  gui.newLabel(pan_fr, 124, 195, 100, 14, '', prop_value),
		lock: gui.newLabel(pan_fr, 167, 141,  14, 14, "img/lock.png"),
		name: "MODE",
		angle: 0,
		focus: chpanKnobFocus
	};
	p.mode.lbl.setText("MODE");

	p.phase=
	{
		val:  gui.newLabel(pan_fr, 249, 155, 60, 14, '', prop_value),
		knob: gui.newKnob (pan_fr, 268, 172, 22, 22, "img/knob_22px.png"),
		lbl:  gui.newLabel(pan_fr, 249, 195, 60, 14, '', prop_value),
		name: "PHASE",
		angle: 0,
		focus: chpanKnobFocus
	};
	p.phase.lbl.setText("PHASE");

	p.ctpan=gui.newPan(pan_fr, 107, 46, 140, 84, "");
	p.ctpan.setParams(70, 62, "img/pan_edit_ball.png");
	p.radius=51;
	p.adelta=180/25;

	p.focuslist=[p.pan,p.mode,p.phase];
	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "PAN"},
		{enabled: true, rot: "MODE",  push: "TAKE"},
		{enabled: true, rot: "PHASE", push: "TAKE"},
		{enabled: false},
		{enabled: false},
		{enabled: false}
	];
	p.sknobs3=
	[
		{enabled: false},
		{enabled: false},
		{enabled: true, rot: "FUNCTION", push: "EXIT"}
	];

// event functions
	p.onOpen =chpanOnOpen;
	p.onClose=chpanOnClose;
	p.onIndi =chpanIndi;
	p.onSoftKnobRot =chpanOnSoftKnobRot;
	p.onSoftKnobDown=chpanOnSoftKnobDown;
	p.onSoftKnobUp  =chpanOnSoftKnobUp;

	pages.chpan=p;
}
function chpanOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

	this.channel=channel_nr;
	this.title.label.setText(host.sprintf("CHANNEL %02d", channel_nr));

	var rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ", bPANO:0, bMODE:0, bMLCK:0, bPHAS:0, bSRCT:0});
	if(rmsg!=null)
	{
		this.onIndi(rmsg);

	// register receive msg handlers
		pages.rxHandlersCh[this.channel].chpan=this;
		mod.setChnKeyLed(channel_nr, keys.ChnOptions, 255);
		mod.setMasterKeyLed(keys.MstChnPan, 255);
	}
}
function chpanIndi(chmsg)
{
	if('bSRCT' in chmsg)
	{
		this.srct=chmsg.bSRCT;
		if(srcIsStereo(this.srct))
		{
			this.mode_count =cfg_surroundMode?7:4;
			this.phase_count=4;
		}
		else
		{
			this.mode_count =2;
			this.phase_count=2;
		}
	}
	if('bMODE' in chmsg)
	{
		this.mode.idx=chmsg.bMODE;
		this.mode.val.setText(mode_txt[this.mode.idx]);
		this.mode.val.setProps({color:color.ltblue});
		this.mode.angle=chpanSetKnobPos(this.mode.knob, this.mode_count-1, this.mode.idx-1);
		sknobsSetOne(1, {angleNrm: this.mode.angle});
		if(this.focus==1)
			sknobsSetOne(6, {angleNrm: this.mode.angle});
	}
	if('bPHAS' in chmsg)
	{
		this.phase.idx=chmsg.bPHAS;
		chpanPhaseSetText(this, this.phase.idx);
		this.phase.val.setProps({color:color.ltblue});
		this.phase.angle=chpanSetKnobPos(this.phase.knob, this.phase_count-1, this.phase.idx-1);
		sknobsSetOne(2, {angleNrm: this.phase.angle});
		if(this.focus==2)
			sknobsSetOne(6, {angleNrm: this.phase.angle});
	}
	if('wvPANO' in chmsg)
	{
		this.panidx=panGetIdx(chmsg.wvPANO[0], chmsg.wvPANO[1]);
	}
// recalculate PAN on pan change and mode change (mode change can change number of balls)
	if(('wvPANO' in chmsg) || ('bMODE' in chmsg))
	{
	// knob
		this.pan.angle=this.panidx/pan_const.val_table_maxind;
		this.pan.knob.setAngleNrm(this.pan.angle);
		sknobsSetOne(0, {angleNrm: this.pan.angle});
		if(this.focus==0)
			sknobsSetOne(6, {angleNrm: this.pan.angle});
	// balls
		var pan_angle=-90+this.panidx/pan_const.val_table_maxind*180;
		if(srcIsStereo(this.srct) && this.mode.idx==mode_type.stereo)
			this.ctpan.setValues(this.radius, this.radius, pan_angle-this.adelta, pan_angle+this.adelta);
		else
			this.ctpan.setValues(this.radius, -1, pan_angle, 0);

	// val
		var val_l=pan_const.val_table[this.panidx][0];
		var val_r=pan_const.val_table[this.panidx][1];
		var val_l_str=(val_l==pan_const.min_db?"OFF":(val_l/10).toString()+" dB");
		var val_r_str=(val_r==pan_const.min_db?"OFF":(val_r/10).toString()+" dB");
		this.pan.val.setText("L "+val_l_str+", R "+val_r_str);
	}
	if('bMLCK' in chmsg)
	{
		this.mlck=chmsg.bMLCK;
		if(this.mlck==2)
		{
			this.mode.lock.show();
			sknobsSetOne(1, {enabled: false});
			if(this.focus==1)
				sknobsSetOne(6, {enabled: false});
		}
		else
		{
			this.mode.lock.hide();
			if(this.focus==1)
				sknobsSetOne(6, {enabled: true});
		}
	}
}
function chpanOnClose()
{
	sknobsHide();
// delete receive msg handlers
	delete pages.rxHandlersCh[this.channel].chpan;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setMasterKeyLed(keys.MstChnPan, 0);
}
function chpanOnSoftKnobRot(idx, delta)
{
	var ctrl;

	idx--; // FIXME
	if(idx==8)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, 2));
		sknobsSetOne(8, {angleNrm: this.focus/2});
		ctrl=this.focuslist[this.focus];
		sknobsSetOne(6, {enabled: true, rot: ctrl.name, push: "TAKE", angleNrm: ctrl.angle});
		if(this.focus==1 && this.mlck==2)
			sknobsSetOne(6, {enabled: false});
		return;
	}

	if(idx==6) idx=this.focus;

	switch(idx)
	{
	case 0:
		var newi=clamp(this.panidx+delta, 0, pan_const.val_table_maxind);
		if(newi!=this.panidx)
			host.sendChnCmsg(this.channel, {id:"WRIN", wvPANO:pan_const.val_table[newi]});
		break;
	case 1:
		if(this.mlck!=2)
		{
			this.mode.idx=clamp(this.mode.idx+delta, 1, this.mode_count);
			this.mode.val.setText(mode_txt[this.mode.idx]);
			this.mode.val.setProps({color:color.yellow});
			this.mode.angle=chpanSetKnobPos(this.mode.knob, this.mode_count-1, this.mode.idx-1);
			sknobsSetOne(1, {angleNrm: this.mode.angle});
		}
		break;
	case 2:
		this.phase.idx=clamp(this.phase.idx+delta, 1, this.phase_count);
		chpanPhaseSetText(this, this.phase.idx);
		this.phase.val.setProps({color:color.yellow});
		this.phase.angle=chpanSetKnobPos(this.phase.knob, this.phase_count-1, this.phase.idx-1);
		sknobsSetOne(2, {angleNrm: this.phase.angle});
		break;
	}
}
function chpanOnSoftKnobDown(idx)
{
	idx--; // FIXME
	if(idx==6) idx=this.focus;

	switch(idx)
	{
	case 1: // mode
		if(this.mlck!=2)
			host.sendChnCmsg(this.channel, {id:"WRIN", bMODE:this.mode.idx});
		break;
	case 2: // phase
		host.sendChnCmsg(this.channel, {id:"WRIN", bPHAS:this.phase.idx});
		break
	}
}
function chpanOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
function chpanPhaseSetText(p, phas)
{
	p.phase.val.setText(srcIsStereo(p.srct)?phase_txt_stereo[phas]:phase_txt_mono[phas]);
}
// ind form 0 to max value
// maxind - indicates max possible values minus 1
function chpanSetKnobPos(knob, maxind, ind)
{
	var angle=ind/maxind;
	knob.setAngleNrm(angle);
	return angle;
}
