// ------------------------ monsrc page ------------------------
const monsrcInput=
[
	{tag: 'none', srci:  -1, name: "NONE"},
	{tag: 'pgmx', srci:  -2, name: "PROGRAM 1"},
	{tag: 'pgmx', srci:  -3, name: "PROGRAM 2"},
	{tag: 'pgmx', srci:  -4, name: "PROGRAM 3"},
	{tag: 'pgmx', srci:  -5, name: "PROGRAM 4"},
	{tag: 'auxx', srci:  -6, name: "AUXILIARY A"},
	{tag: 'auxx', srci:  -7, name: "AUXILIARY B"},
	{tag: 'auxx', srci:  -8, name: "AUXILIARY C"},
	{tag: 'auxx', srci:  -9, name: "AUXILIARY D"},
	{tag: 'extx', srci: -10, name: "EXTERNAL 1"},
	{tag: 'extx', srci: -11, name: "EXTERNAL 2"}
];

function monSSELtoID(ssel)
{
	switch(ssel)
	{
	default:
	case monInput.none : return -1;
	case monInput.pgm1 : return -2;
	case monInput.pgm2 : return -3;
	case monInput.pgm3 : return -4;
	case monInput.pgm4 : return -5;
	case monInput.send1: return -6;
	case monInput.send2: return -7;
	case monInput.send3: return -8;
	case monInput.send4: return -9;
	case monInput.ext1 : return -10;
	case monInput.ext2 : return -11;
	}
}

function monIDtoSSEL(id)
{
	switch(id)
	{
	default:
	case  -1: return monInput.none;
	case  -2: return monInput.pgm1;
	case  -3: return monInput.pgm2;
	case  -4: return monInput.pgm3;
	case  -5: return monInput.pgm4;
	case  -6: return monInput.send1;
	case  -7: return monInput.send2;
	case  -8: return monInput.send3;
	case  -9: return monInput.send4;
	case -10: return monInput.ext1;
	case -11: return monInput.ext2;
	}
}

function monSTAGtoID(stag)
{
	var rmsg, n, tag, src;

	switch(stag)
	{
	case '0000': return -1;
	case 'PGM1': return -2;
	case 'PGM2': return -3;
	case 'PGM3': return -4;
	case 'PGM4': return -5;
	case 'AUX1': return -6;
	case 'AUX2': return -7;
	case 'AUX3': return -8;
	case 'AUX4': return -9;
	}
// check for source tag
	rmsg=host.sendCmsgRq({id:'READ', bSRLE:0});
	if(rmsg!=null && ('mSRLE' in rmsg))
	{
		for(n=1; n<=rmsg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in rmsg.mSRLE)) continue;

			src=rmsg.mSRLE[tag];
			if(!('dSRCI' in src) || !('bvSTAG' in src)) continue;

			if(stag==host.arrtostr(src.bvSTAG))
				return src.dSRCI;
		}
	}
	return -1;
}

function monIDtoSTAG(id)
{
	var rmsg, n, tag, src;

	switch(id)
	{
	case  -1: return '0000';
	case  -2: return 'PGM1';
	case  -3: return 'PGM2';
	case  -4: return 'PGM3';
	case  -5: return 'PGM4';
	case  -6: return 'AUX1';
	case  -7: return 'AUX2';
	case  -8: return 'AUX3';
	case  -9: return 'AUX4';
	}

// check for source tag
	rmsg=host.sendCmsgRq({id:'READ', bSRLE:0});
	if(rmsg!=null && ('mSRLE' in rmsg))
	{
		for(n=1; n<=rmsg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in rmsg.mSRLE)) continue;

			src=rmsg.mSRLE[tag];
			if(!('dSRCI' in src) || !('bvSTAG' in src)) continue;

			if(id==src.dSRCI)
				return host.arrtostr(src.bvSTAG);
		}
	}
	return '0000';
}

function fillMonSrcList(list, spec, mask, curId, selId)
{
	var p, n, src;
	var rmsg, tag;

// get source list if required
	if(mask!=null)
		rmsg=getSourceList(mask, true);
	else
		rmsg=null;

// clear list
	list.clear();

// add internal buses
	for(p in monsrcInput)
	{
		src=monsrcInput[p];
		if((src.tag in spec) && spec[src.tag])
		{
			if(curId==src.srci)
				list.insert(src.name, src.srci, 1, 1);
			else
				list.insert(src.name, src.srci, 0, 0);
		}
	}
// add external sources
	if(rmsg!=null && ('mSRLE' in rmsg))
	{
		for(n=1; n<=rmsg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in rmsg.mSRLE)) continue;

			src=rmsg.mSRLE[tag];
			if(!('dSRCI' in src) || !('sSRCN' in src)) continue;

			if(curId==src.dSRCI)
				list.insert(src.sSRCN, src.dSRCI, 1, 1);
			else
				list.insert(src.sSRCN, src.dSRCI, 0, 0);
		}
	}
// set selection
	setListSelection(list, selId);
}

function fillMonSrcListType(list, type, curId, selId)
{
	switch(type)
	{
	case chn_mon1:
		fillMonSrcList(list, {none:true, pgmx:mstEnable.crmo_pgm, auxx:mstEnable.crmo_aux, extx:mstEnable.crmo_ext}, null, curId, selId);
		break;
	case chn_hp:
		fillMonSrcList(list, {none:true, pgmx:mstEnable.crhp_pgm, auxx:mstEnable.crhp_aux, extx:mstEnable.crhp_ext}, null, curId, selId);
		break;
	case chn_mon2:
		fillMonSrcList(list, {none:true, pgmx:mstEnable.stmo_pgm, auxx:mstEnable.stmo_aux}, mstEnable.stmo_ext?src_list_mask.mon2:null, curId, selId);
		break;
	case chn_ext1:
		fillMonSrcList(list, {none:true}, src_list_mask.mon1, curId, selId);
		break;
	case chn_ext2:
		fillMonSrcList(list, {none:true}, src_list_mask.mon1, curId, selId);
		break;
	}
}

function monsrcPageCreate()
{
	var p={id:"monsrc"};
	var f;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 144, 12, "img/monitor_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);

	var fr=gui.newFrame(f, 49, 131, 353, 329, "img/mst_monsrc_bg.png");
	p.caption=gui.newLabel(fr,  50, 22, 100, 14, '', prop_value_left);
	p.cursrc =gui.newLabel(fr, 170, 20, 100, 19, '', prop_src);
	p.list=gui.newList(fr, 70, 77, 209, 186, '', prop_list);
	p.list.setProps({border:1});

	GUI_createSmallMeter(fr, 329, 39, mtrGUI.monsrc);

// softknobs
	p.sknobs6=
	[
		{enabled: true,  rot: "SELECT", push: "TAKE", jog: true, enter: true},//updn: true, list: p.list},
		{enabled: false},
		{enabled: false, push: "PREVIOUS"},
		{enabled: false},
		{enabled: false},
		{enabled: false}
	];
	p.sknobs3=
	[
		{enabled: true,  rot: "SELECT", push: "TAKE", jog: true, enter: true},//updn: true, list: p.list},
		{enabled: false, push: "PREVIOUS"},
		{enabled: true,  push: "EXIT"}
	];

// event functions
	p.onOpen =monsrcOnOpen;
	p.onClose=monsrcOnClose;
	p.onSoftKnobRot =monsrcOnSoftKnobRot;
	p.onUpDn=function(delta){this.onSoftKnobRot(1, delta)};
	p.onSoftKnobDown=monsrcOnSoftKnobDown;
	p.onSoftKnobUp  =monsrcOnSoftKnobUp;
	p.onSrcLstUpdate=monsrcReload;
// autoclose timeout:
	p.timeout=null;
	p.onChange=function()
	{
		this.timeout=host.resetTimeout(this.timeout, mon_const.page_close_time, this.closePage, this);
	}
	p.closePage=function()
	{
		this.timeout=null;
		closePage(this, this.channel);
	}

	pages.monsrc=p;
}

function monsrcOnOpen(mon_chn)
{
	var ind, rmsg;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.channel=mon_chn;
	this.prev=null;

	switch(this.channel)
	{
	case chn_mon1:
		this.title.label.setText("MONITOR 1");
		this.caption.setText("MONITOR 1 SOURCE");
		rmsg=host.sendNestCmsgRq('mCRMO', {id:"READ", bSSEL:0});
		if(rmsg!=null && ('bSSEL' in rmsg))
			this.srci=monSSELtoID(rmsg.bSSEL);
		pages.rxHandlersGlobal.monsrc=monsrcOnIndiMon1;
		this.mtr_id=mtrEng.crmo;
		break;
	case chn_hp:
		this.title.label.setText("HEADPHONES");
		this.caption.setText("HEADPHONES SOURCE");
		rmsg=host.sendNestCmsgRq('mCRHP', {id:"READ", bSSEL:0});
		if(rmsg!=null && ('bSSEL' in rmsg))
			this.srci=monSSELtoID(rmsg.bSSEL);
		pages.rxHandlersGlobal.monsrc=monsrcOnIndiHP;
		this.mtr_id=mtrEng.crhp;
		break;
	case chn_mon2:
		this.title.label.setText("MONITOR 2");
		this.caption.setText("MONITOR 2 SOURCE");
		rmsg=host.sendNestCmsgRq('mSTMO', {id:"READ", bSTAG:0});
		if(rmsg!=null && ('bvSTAG' in rmsg))
			this.srci=monSTAGtoID(host.arrtostr(rmsg.bvSTAG));
		pages.rxHandlersGlobal.monsrc=monsrcOnIndiMon2;
		this.mtr_id=mtrEng.stmo;
		break;
	case chn_ext1:
		this.title.label.setText("EXT 1");
		this.caption.setText("EXTERNAL 1 SOURCE");
		rmsg=host.sendNestCmsgRq('mCRMO', {id:"READ", bSRCI:0});
		if(rmsg!=null && ('dSRCI' in rmsg))
			this.srci=rmsg.dSRCI;
		pages.rxHandlersGlobal.monsrc=monsrcOnIndiExt1;
		this.mtr_id=mtrEng.ext1;
		break;
	case chn_ext2:
		this.title.label.setText("EXT 2");
		this.caption.setText("EXTERNAL 2 SOURCE");
		rmsg=host.sendNestCmsgRq('mCRHP', {id:"READ", bSRCI:0});
		if(rmsg!=null && ('dSRCI' in rmsg))
			this.srci=rmsg.dSRCI;
		pages.rxHandlersGlobal.monsrc=monsrcOnIndiExt2;
		this.mtr_id=mtrEng.ext2;
		break;
	}
	gui.linkMeter(mtrGUI.monsrc, this.mtr_id);
	host.requestMeter(this.mtr_id, true);
	fillMonSrcListType(this.list, this.channel, this.srci, this.srci);
	this.cursrc.setText(getListActiveTxt(this.list));
	sknobsSetOne(0, {angleNrm: this.list.selection/(this.list.count-1)});
	sknobsSetOne(6, {angleNrm: this.list.selection/(this.list.count-1)});
// autoclose timer
	this.onChange();
}
function monsrcOnClose()
{
	this.timeout=host.clearTimeout(this.timeout);
	sknobsHide();
	gui.linkMeter(mtrGUI.monsrc, 0);
	host.requestMeter(this.mtr_id, false);
	if('monsrc' in pages.rxHandlersGlobal)
		delete pages.rxHandlersGlobal.monsrc;
}

function monsrcSelect(channel, id)
{
	switch(channel)
	{
	case chn_mon1:
		host.sendNestCmsg('mCRMO', {id:'WRIN', bSSEL:monIDtoSSEL(id)});
		break;
	case chn_hp:
		host.sendNestCmsg('mCRHP', {id:'WRIN', bSSEL:monIDtoSSEL(id)});
		break;
	case chn_mon2:
		host.sendNestCmsg('mSTMO', {id:'WRIN', bvSTAG:strToArr(monIDtoSTAG(id))});
		break;
	case chn_ext1:
		host.sendNestCmsg('mCRMO', {id:'WRIN', dSRCI:id});
		break;
	case chn_ext2:
		host.sendNestCmsg('mCRHP', {id:'WRIN', dSRCI:id});
		break;
	}
}

function monsrcOnSoftKnobRot(idx, delta)
{
	if(idx==1 || idx==7)
	{
		this.list.advance(delta);
		sknobsSetOne(0, {angleNrm: this.list.selection/(this.list.count-1)});
		sknobsSetOne(6, {angleNrm: this.list.selection/(this.list.count-1)});
		this.onChange();
	}
}
function monsrcOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1:
	case 7:
		monsrcSelect(this.channel, this.list.selId);
		this.onChange();
		break;
	case 3:
	case 8:
		if(this.prev!=null)
			monsrcSelect(this.channel, this.prev)
		this.onChange();
		break;
	}
}
function monsrcOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 9: // Combo3
		closePage(this, this.channel);
		break;
	}
}

function monsrcNewSrci(srci)
{
	var p=pages.monsrc;

	p.prev=p.srci;
	p.srci=srci;
	p.cursrc.setText(setListActive(p.list, p.srci));
	if(p.prev!=null)
	{
		sknobsSetOne(0, {enabled:true});
		sknobsSetOne(7, {enabled:true});
	}
}

function monsrcOnIndiMon2(msg)
{
	if(('mSTMO' in msg) && ('bvSTAG' in msg.mSTMO)) monsrcNewSrci(monSTAGtoID(host.arrtostr(msg.mSTMO.bvSTAG)));
}
function monsrcOnIndiMon1(msg)
{
	if(('mCRMO' in msg) && ('bSSEL' in msg.mCRMO)) monsrcNewSrci(monSSELtoID(msg.mCRMO.bSSEL));
}
function monsrcOnIndiHP(msg)
{
	if(('mCRHP' in msg) && ('bSSEL' in msg.mCRHP)) monsrcNewSrci(monSSELtoID(msg.mCRHP.bSSEL));
}
function monsrcOnIndiExt1(msg)
{
	if(('mCRMO' in msg) && ('dSRCI' in msg.mCRMO)) monsrcNewSrci(msg.mCRMO.dSRCI);
}
function monsrcOnIndiExt2(msg)
{
	if(('mCRHP' in msg) && ('dSRCI' in msg.mCRHP)) monsrcNewSrci(msg.mCRHP.dSRCI);
}

function monsrcReload(mask)
{
	switch(this.channel)
	{
	case chn_mon2:
		if(mask[src_list_mask.mon2]==0) return;
		break;
	case chn_ext1:
	case chn_ext2:
		if(mask[src_list_mask.mon1]==0) return;
		break;
	default:
		return;
		break;
	}
	fillMonSrcListType(this.list, this.channel, this.srci, this.list.selId);
	sknobsSetOne(0, {angleNrm: this.list.selection/(this.list.count-1)});
	sknobsSetOne(6, {angleNrm: this.list.selection/(this.list.count-1)});
}
