// ------------------------ global sends page ------------------------

function sendsCreateObject(frame, x, y, title, tag)
{
	var obj={};

	obj.on   =gui.newPicture(frame, x+21, y   , 20, 20, "img/on_off.png");
	obj.knob =gui.newKnob   (frame, x+20, y+40, 22, 22, "img/knob_22px.png");
	obj.val  =gui.newLabel  (frame, x   , y+25, 60, 14, '', prop_value);
	obj.label=gui.newLabel  (frame, x+ 2, y+63, 60, 14, '', prop_value);
	obj.label.setText(title);
	obj.tag=tag;
	obj.preview=false;
	obj.onsw=false;
	obj.msgn=0;

	return obj;
}

function sendsPageCreate()
{
	var p={id:"sends"};
	var f;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	gui.newFrame(f, 150, 60, 144, 12, "img/monitor_options.png");
	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);
	p.title.label.setText("SENDS");

	var aux_fr=gui.newFrame(p.frame, 49, 131, 353, 169, "img/mst_sends_bg.png");

	p.sends=[];
	p.sends[0]=sendsCreateObject(aux_fr,  13, 37, "SEND A", 'mSND1');
	p.sends[1]=sendsCreateObject(aux_fr,  90, 37, "SEND B", 'mSND2');
	p.sends[2]=sendsCreateObject(aux_fr, 163, 37, "SEND C", 'mSND3');
	p.sends[3]=sendsCreateObject(aux_fr, 240, 37, "SEND D", 'mSND4');

// indicates which channel will be controlled with preview knob
	p.prv_select=0;
	p.preview=gui.newFrame(aux_fr, 15, 118, 60, 39, '');
	p.preview.line =gui.newPicture(p.preview, 29,  0,  2, 22, "img/line_vert.png");
	p.preview.label=gui.newLabel  (p.preview,  0, 24, 60, 14, '', prop_value);
	p.preview.label.setText("PREVIEW OFF");

	p.sknobs6=
	[
		{enabled: true, rot: "SEND A", push: "OFF"},
		{enabled: true, rot: "SEND B", push: "OFF"},
		{enabled: true, rot: "SEND C", push: "OFF"},
		{enabled: true, rot: "SEND D", push: "OFF"},
		{enabled: false},
		{enabled: true, rot: "SELECT", push: "PREVIEW"}
	];

// event functions
	p.onOpen =sendsOnOpen;
	p.onClose=sendsOnClose;
	p.onSoftKnobRot =sendsOnSoftKnobRot;
	p.onSoftKnobDown=sendsOnSoftKnobDown;
	p.onSoftKnobUp  =sendsOnSoftKnobUp;

	pages.sends=p;
}
function sendsOnOpen(channel_nr)
{
	var rmsg, read_msg={id:"READ", bMSGN:0, bONSW:0, bPREV:0};

	sknobsShow(this.sknobs6);
	rmsg=host.sendCmsgRq({id:"NEST", mSND1:read_msg, mSND2:read_msg, mSND3:read_msg, mSND4:read_msg});
	if(rmsg!=null)
	{
		sendsIndi(rmsg);

	// register receive msg handlers
		pages.rxHandlersGlobal.sendsIndi=sendsIndi;
		mod.setMasterKeyLed(keys.MstSendRet, 255);
	}
}
function sendsOnClose()
{
// turn preview off if it is ON
	if(this.sends[this.prv_select].preview) host.sendNestCmsg(this.sends[this.prv_select].tag, {id:'WRIN', bPREV:0});
	sknobsHide();
// delete receive msg handlers
	delete pages.rxHandlersGlobal.sendsIndi;
	mod.setMasterKeyLed(keys.MstSendRet, 0);
}
function sendsIndi(msg)
{
	var p=pages.sends;
	var n, obj;

	for(n=0; n<4; n++)
	{
		obj=p.sends[n];
		if(obj.tag in msg)
			sendsIndiEx(msg[obj.tag], p, obj, n);
	}
}
function sendsIndiEx(submsg, page, bus_obj, soft_knob_idx)
{
	var angl;

	if('wMSGN' in submsg)
	{
		bus_obj.msgn=submsg.wMSGN;
		angl=knobSetValue(bus_obj, bus_obj.msgn, aux_const);
		sknobsSetOne(soft_knob_idx, {angleNrm:angl});
	}
	if('bONSW' in submsg)
	{
		bus_obj.onsw=submsg.bONSW!=0;
		bus_obj.on.setIndex(bus_obj.onsw?1:0);
		sknobsSetOne(soft_knob_idx, {push:bus_obj.onsw?"ON":"OFF"});
	}
	if('bPREV' in submsg)
	{
		bus_obj.preview=submsg.bPREV!=0;
		sendsSelectPre(page);
	}
}
function sendsSelectPre(p)
{
	const xpos=[15,92,165,242];

	p.preview.moveTo(xpos[p.prv_select], 118);
	p.preview.label.setText(p.sends[p.prv_select].preview?"PREVIEW ON":"PREVIEW OFF");
	sknobsSetOne(5, {angleNrm:p.prv_select/3});
}
function sendsOnSoftKnobRot(idx, delta)
{
	switch (idx){
	case 1:
	case 2:
	case 3:
	case 4:
		sendsSetGain(this.sends[idx-1].tag, this.sends[idx-1].msgn, delta);
		break;
	case 6:
		if(delta==0) break;
		if(this.sends[this.prv_select].preview) break;	// Preview is on, don't allow to navigate from it
		this.prv_select=clamp(this.prv_select+(delta>0?1:-1), 0, 3);
		sendsSelectPre(this);
		break;
	}
}
function sendsOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1:
	case 2:
	case 3:
	case 4:
		toggleVal(this.sends[idx-1].tag, 'bONSW', this.sends[idx-1].onsw);
		break;
	case 6:
		host.sendNestCmsg(this.sends[this.prv_select].tag, {id:'WRIN', bPREV:1});
		break;
	}
}
function sendsOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
		host.sendNestCmsg(this.sends[this.prv_select].tag, {id:'WRIN', bPREV:0});
		break;
	}
}
function sendsSetGain(tag, oldval, delta)
{
	var newgain=clamp(oldval+(delta*aux_const.step), aux_const.min, aux_const.max);

	host.sendNestCmsg(tag, {id:"WRIN", wMSGN:newgain});
}
